#include <..\bl_files.h>
#include <../bl_graph.h>
#include <io.h>

typedef struct {
    unsigned short  width,height;
    unsigned char   *ptr;
} bl_char;

bl_char blfont[256],sysfont[256];

void bl_drawchar (unsigned short x,unsigned short y,unsigned char ch,
                    unsigned char r,unsigned char g,unsigned char b)
  {
      int i,j;
      unsigned char *sprpos;
      unsigned short *dest;

      dest=(unsigned short *)Videobuf; // 
        dest+=640*y+x;
        sprpos=blfont[ch].ptr;
        for(i = 0; i < blfont[ch].height; i++)
          {
           for(j = 0; j < blfont[ch].width; j++)
             {
                 if (*sprpos)
                   {
                       *dest=getrgbcolor16(*sprpos*r/255,*sprpos*g/255,*sprpos*b/255);
                   }
                 dest++;
                 sprpos++;
             }
           dest+=(640-blfont[ch].width);
          }

  }

void bl_drawstring (unsigned short x,unsigned short y,unsigned char *str,
                    unsigned char r,unsigned char g,unsigned char b)
  {
      int i;
      unsigned short ax;

      i=0;
      ax=x;
      while (str[i]!=NULL)
       {
           bl_drawchar(ax,y,str[i],r,g,b);
           ax+=blfont[str[i]].width+3;
           i++;
       }
  }


int bl_initfont (unsigned char *fontdef,unsigned char *sysfont)
  {
      unsigned char n,i;
      unsigned long sprofs,sprsize;

      printf("loading fonts... %s",fontdef);
      
      textofs=findfile(resfile,fontdef,&textsize);

      if (!textofs) return(0);

      lseek(resfile,textofs,SEEK_SET);
      textpos=0;

      while ((textpos<textsize) && strcmp(rwstring,"fend"))
        {
            lseek(resfile,textofs+textpos,SEEK_SET);
            readword(resfile);
            //if (isdebug)
            //printf("%s ",rwstring);
            n=(char)atol(rwstring);
            readword(resfile);
            //if (isdebug)
            //printf("%s \n",rwstring);

            sprofs=findfile(resfile,rwstring,&sprsize);
            if (!sprofs) continue;

            lseek(resfile,sprofs,SEEK_SET);
            _dos_read(resfile,&blfont[n].width,2,1);
            _dos_read(resfile,&blfont[n].height,2,1);

            blfont[n].ptr=(unsigned char*)calloc(blfont[n].width*blfont[n].height,1);
            if (!blfont[n].ptr) continue;

            _dos_read(resfile,blfont[n].ptr,blfont[n].width*blfont[n].height,1);
        }
     return(1);
  }
